' QBTERM.BAS - QBasic Terminal Program
'
' Serial interface experiment for the Parallax BASIC Stamp
' Complimentary stamp program is called STMPTERM.BAS
'
' Jon Williams
' Riverside, CA
' CIS 73110,3272


' General definitions
'
DEFINT A-Z

CONST TRUE = -1
CONST FALSE = 0
CONST Delay = 1750                              ' for 25 MHz 486DX

DIM SHARED done%, stampData%, msg$, stamp$



' Make the screen look like the Stamp editor/downloader
'
Scrn:   COLOR 7, 1                              ' blue background
        CLS
        COLOR 7, 7
        LOCATE 1, 1: PRINT SPACE$(80)           ' title banner
        LOCATE 2, 1: PRINT SPACE$(80)
        LOCATE 3, 1: PRINT SPACE$(80)
        COLOR 15
        LOCATE 2, 2
        PRINT "[CLR]  [HOME]  [BS]  [GET]  [QUIT]";
        COLOR 0
        LOCATE 2, 54
        PRINT "QBTerm for the BASIC Stamp"
        VIEW PRINT 5 TO 24                      ' limit lines used
        COLOR 7, 1


' initialize work variables and soft keys
'
Init:   done% = FALSE
        stampData = FALSE
        stamp$ = ""


' set up the communications parameters
'
ComIni: OPEN "COM1:2400,N,8,1,CD0,CS0,DS0,OP0,RS" FOR RANDOM AS #1
        COM(1) ON
        ON COM(1) GOSUB CmHndl


' main body of program
'
Main:   DO
          COLOR 3
          PRINT " Message to Stamp..... ";
          COLOR 7
          LINE INPUT "", msg$
          IF UCASE$(msg$) = "[CLR]" THEN msg$ = CHR$(3)
          IF UCASE$(msg$) = "[HOME]" THEN msg$ = CHR$(13)
          IF UCASE$(msg$) = "[BS]" THEN msg$ = CHR$(8)
          IF UCASE$(msg$) = "[GET]" THEN msg$ = CHR$(5)
          IF UCASE$(msg$) = "[QUIT]" THEN done% = TRUE: msg$ = ""
          FOR X = 1 TO LEN(msg$)
            PRINT #1, MID$(msg$, X, 1)
            FOR Y = 1 TO Delay: NEXT Y
          NEXT X
          IF stampData% = TRUE THEN GOSUB ShStmp
        LOOP UNTIL done% = TRUE


' shut down cleanly
'
ShutDn: COM(1) OFF                              ' disable com port
        VIEW PRINT 1 TO 25                      ' clear the screen
        COLOR 7, 0
        CLS
        SYSTEM


' Process incoming message from stamp
'
CmHndl: DO WHILE NOT EOF(1)
          stamp$ = stamp$ + INPUT$(LOC(1), #1)
          FOR X = 1 TO Delay: NEXT X
        LOOP
        stampData% = TRUE
        RETURN


' show the data comming back from the Stamp
'
ShStmp: COLOR 11
        PRINT " Message from Stamp... ";
        COLOR 14
        PRINT stamp$
        stamp$ = ""
        stampData = FALSE
        RETURN

